Subject: Re: The git spring cleanup challenge

From: Felipe Contreras <[email-masked]>
Date: Fri, 02 Jul 2021 05:12:47 -0500

Ævar Arnfjörð Bjarmason wrote:
> On Thu, Jun 03 2021, Felipe Contreras wrote:
> > Ævar Arnfjörð Bjarmason wrote:

> >> We could then just extend the include syntax rather easily to include
> >> "libraries", which would be like the current include.path, but would
> >> understand a library:: prefix (better name bikeshedding welcome). We'd
> >> then just ship these in /usr/share/git-core/config/includes or whatever,
> >> e.g. /usr/share/git-core/config/includes/aliases/svn-like.cfg
> >
> > I wouldn't be against some some suggested defaults, but *in addition* to
> > some hardcoded default aliases that are documented.
> 
> I'm talking about in terms of the flexibility of implementation of
> on-by-default defaults. We could implement it as I suggested and then
> just have a core.defaultIncludes, which would by default be set to
> git::aliases/svn-like.cfg or whatever, i.e. equivalent to:
> 
>     [core]
>     defaultIncludes = "git::default.cfg"
> 
> Which itself would include a
> /usr/share/git-core/config/includes/default.cfg which would do:

I really gave this a try, but the problem is that git doesn't even have
a stardard location to install shared files.

I started with $sharedir, but that's not git-specific. Then I added
$gitsharedir which required a bunch of changes to the Makefile, and
eventually I decided against it.

We don't have standard location for shared files. Period.

> In a way this is total bikeshedding, I just think it's worth doing it
> this way up-front.

Yes, maybe so, but git infraestructure is completely unprepared for that
(at this point).

So I just decied to hard-code them [1]

[1] https://lore.kernel.org/git/[email-masked]/

-- 
Felipe Contreras